#version 450 core

struct Particle
{
    mat4 modelMatrix;
    vec4 color;
};

layout(location = 0) in vec3 position;
layout(std430, binding = 0) buffer modelmatrices
{
    Particle particles[];
};

uniform mat4 viewProjection;
out vec4 f_color;

void main(){
    f_color = particles[gl_InstanceID].color;
    gl_Position = viewProjection * particles[gl_InstanceID].modelMatrix * vec4(position, 1);
}