#version 450 core

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 texCoordinate;

out vec2 fragTexCoordinate;

uniform mat4 modelMatrix;

void main() {
    gl_Position = modelMatrix * vec4(position.x, position.y, 0.0f, 1.0f);

    fragTexCoordinate = texCoordinate;
}